	org 26000
	jp 0x8000
scrolltext
	incbin 'scrolltext.txt'
	db 0

	org 32768

	call stc_init_entry
	; set up interrupts
	ld hl,0xbe00
	ld de,0xbe01
	ld bc,0x0100
	ld (hl),0xbf
	ldir
	di
	ld a,0xbe
	ld i,a
	im 2
	ei
	
	call set_initial_mask
	
	; draw line / set attributes above scroller
	ld hl,0x50c0
	ld (hl),0xff
	ld de,0x50c1
	ld bc,0x1f
	ldir
	ld hl,0x5ac0
	ld (hl),0x47
	ld de,0x5ac1
	ld bc,0x3f
	ldir
	
mainloop
	halt
non_interrupt_action
	jp mainloop
	
wavebg
sineypos
	ld hl,sine
	inc l
	inc l
	ld (sineypos+1),hl
	ld a,(hl)
	add a,4
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ex de,hl

sinexpos
	ld hl,sine
	inc l
	inc l
	inc l
	ld (sinexpos+1),hl
	ld l,(hl)
	ld h,0
	add hl,de
	ex de,hl
	ld hl,0x0a20
	sbc hl,de

	ld bc,background
	add hl,bc
	ex de,hl
	add hl,bc	; now hl and de are the two pointers within background
	ex de,hl
	
	exx
	ld hl,image_mask
	ld de,0x5800
bgcolour
	ld c,4+8*4
	exx
	
; two lines of no-masking
	ld b,0x02
copybg1
	push bc
	rept 0x20
		ld a,(de)
		inc e
		xor (hl)
		inc l
		exx
		and c
		ld (de),a
		inc e
		exx
	endm
	; advance to next line of ring pattern
	ld bc,0x0020
	add hl,bc
	ex de,hl
	add hl,bc
	ex de,hl
	
	pop bc
	dec b
	jp nz,copybg1

; then 0x10 lines of masking
	ld b,0x10
copybg
	push bc
	rept 4
		ld a,(de)
		inc e
		xor (hl)
		inc l
		exx
		and c
		ld (de),a
		inc e
		exx
	endm
	rept 3
		rept 7
			ld a,(de)
			inc e
			xor (hl)
			inc l
			exx
			and c
			and (hl)
			inc l
			or (hl)
			inc l
			ld (de),a
			inc e
			exx
		endm
		ld a,(de)
		inc e
		xor (hl)
		inc l
		exx
		and c
		and (hl)
		inc l
		or (hl)
		inc hl
		ld (de),a
		inc e
		exx
	endm
	rept 3
		ld a,(de)
		inc e
		xor (hl)
		inc l
		exx
		and c
		ld (de),a
		inc e
		exx
	endm
	ld a,(de)
	inc e
	xor (hl)
	inc l
	exx
	and c
	ld (de),a
	inc de
	exx

	; advance to next line of ring pattern
	ld bc,0x0020
	add hl,bc
	ex de,hl
	add hl,bc
	ex de,hl
	
	pop bc
	dec b
	jp nz,copybg

; then 4 lines of no-masking
	ld b,0x04
copybg2
	push bc
	rept 0x20
		ld a,(de)
		inc e
		xor (hl)
		inc l
		exx
		and c
		ld (de),a
		inc e
		exx
	endm
	; advance to next line of ring pattern
	ld bc,0x0020
	add hl,bc
	ex de,hl
	add hl,bc
	ex de,hl
	
	pop bc
	dec b
	jp nz,copybg2

	ret

dither
ditherpos
;	ld a,0x38
	ld a,0x08
	inc a
	and 0x3f
	ld (ditherpos+1),a
	ld h,0xbb
	ld l,a
	ld a,(hl)
	cp 0x01
	ret z	; 0x01 = no change
	cp 0x02
	jp z,trigger_image_to_paper_mask
	cp 0x03
	jp z,trigger_image_to_ink_mask
	ld e,a
	ld d,e

	set 6,l
	ld h,(hl)
	ld l,0
	
	ld bc,0x0400
	call spdump	; hl = 4100
	add hl,bc
	call spdump	; hl = 4500
	add hl,bc
	call spdump	; hl = 4900
	add hl,bc
	call spdump	; hl = 4d00
	ld bc,0x03c0
	add hl,bc
	call spdump60	; hl = 50c0
	ld bc,0x0400
	add hl,bc
	; continue on to spdump60
	
spdump60
	ld (screensp60+1),hl
	ld (dither_sp_back_60+1),sp
screensp60
	ld sp,0

	rept 0x60
		push de
	endm
	
dither_sp_back_60
	ld sp,0
	ret

spdump
	ld (screensp+1),hl
	ld (dither_sp_back+1),sp
screensp
	ld sp,0

	rept 0x80
		push de
	endm
	
dither_sp_back
	ld sp,0
	ret
	
set_initial_mask
	; mask byte = 0xff, colour byte = 0x00
	ld hl,image_mask
	ld b,192
set_initial_mask_lp
	ld (hl),0xff
	inc hl
	ld (hl),0x00
	inc hl
	ld (hl),0xff
	inc hl
	ld (hl),0x00
	inc hl
	ld (hl),0xff
	inc hl
	ld (hl),0x00
	inc hl
	djnz set_initial_mask_lp
	ret
	
trigger_image_to_ink_mask
	ld hl,image_to_ink_mask
	ld (non_interrupt_action+1),hl
	ret
trigger_image_to_paper_mask
	ld hl,image_to_paper_mask
	ld (non_interrupt_action+1),hl
	ret

image_to_ink_mask
	call get_next_image

	call get_next_gfx_colour
	ld (gfx_ink_col+1),a

	ld hl,image_mask

	ld b,48
i2im_bytelp
	push bc
	ld b,8
	ld a,(de)
	ld c,a
i2im_bitlp
	sla c
	jp c,i2im_bit_set

i2im_bit_reset
	ld a,(hl)
	or 0x07
	ld (hl),a
	inc hl
	ld a,(hl)
	and 0xf8
	ld (hl),a
	inc hl
	jp i2im_bit_next
i2im_bit_set
	ld a,(hl)
	and 0xf8
	ld (hl),a
	inc hl
	ld a,(hl)
	and 0xf8
gfx_ink_col
	or 0x03
	ld (hl),a
	inc hl
i2im_bit_next
	djnz i2im_bitlp
	inc de
	pop bc
	djnz i2im_bytelp
	ld hl,mainloop
	ld (non_interrupt_action+1),hl
	jp mainloop

image_to_paper_mask
	call get_next_image

	call get_next_gfx_colour
	add a,a
	add a,a
	add a,a
	ld (gfx_paper_col+1),a

	ld hl,image_mask
	ld b,48
i2pm_bytelp
	push bc
	ld b,8
	ld a,(de)
	ld c,a
i2pm_bitlp
	sla c
	jp c,i2pm_bit_set

i2pm_bit_reset
	ld a,(hl)
	or 0x38
	ld (hl),a
	inc hl
	ld a,(hl)
	and 0xc7
	ld (hl),a
	inc hl
	jp i2pm_bit_next
i2pm_bit_set
	ld a,(hl)
	and 0xc7
	ld (hl),a
	inc hl
	ld a,(hl)
	and 0xc7
gfx_paper_col
	or 0x18 ; magenta
	ld (hl),a
	inc hl
i2pm_bit_next
	djnz i2pm_bitlp
	inc de
	pop bc
	djnz i2pm_bytelp
	ld hl,mainloop
	ld (non_interrupt_action+1),hl
	jp mainloop

get_next_image
next_image_ptr
	ld hl,image_sequence
next_image_loop
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld (next_image_ptr+1),hl
	ld a,d
	or e
	ret nz	; if de != 0, return with that value
	ld hl,gfx_col_sequence	; also reset gfx colours
	ld (next_gfx_col_pos+1),hl
	ld hl,image_sequence
	jr next_image_loop

get_next_gfx_colour
next_gfx_col_pos
	ld hl,gfx_col_sequence
	ld a,(hl)
	inc hl
	ld (next_gfx_col_pos+1),hl
	ret

scroller
scroll_pix_count
	ld a,4	; scrolls until next character
	dec a
	jr nz,scroll_no_new_char

scrolltext_pos
	ld hl,scrolltext
	ld a,(hl)
	or a
	jr nz,no_scroll_wrap
	ld hl,scrolltext
	ld a,(hl)
no_scroll_wrap
	inc hl
	ld (scrolltext_pos+1),hl

	; get bitmap of char
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld de,font-0x0200
	add hl,de
	ld de,scroll_char_store
	rept 16
		ldi
	endm

	ld a,4
scroll_no_new_char
	ld (scroll_pix_count+1),a
	ld b,8
	ld hl,scroll_char_store + 1
	exx
	ld hl,0x50ff

scroll_row
	push hl

	exx
	rld
	dec hl
	rld
	inc hl
	inc hl
	inc hl
	exx

	rept 32
		rld
		dec l
	endm

	pop hl
	inc h
	djnz scroll_row
	ret

scroll_char_store
	ds 16

gfx_col_sequence
	db 0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0
	db 7,7,7,7
	db 7,7,7,7
	db 7,7,7,7
	db 7,7,7,7
	db 7,7,7,7
	db 7,7,7,7,7,7,7,7
	db 7,7,7,7,7,7,5,5
	db 7,7,5,5
	db 7,7,5,5,7,7,5,5
	db 7,7,7,7,7,7,7,7
	db 7,7,7,7,7,7,7,7
	db 7,7,7,7,7,7,7,7
	db 7,7,7,7,7,7,7,7
	db 2,3,4,5,6,5,4,3
	db 0,0,0,0,0,0,0,0
	db 5,5,5,5,5,5,5,5
	db 7,7,7,7,7,7,7,7
	db 3,3,2,2,1,1,0,0
	db 0,0,1,1,2,2,3,3
	db 7,7,7,7,7,7,7,7
	db 5,5,5,5,5,5,5,5
	db 6,6,2,2,3,3,3,3
	db 6,6,3,3,1,1,2,2
	db 4,4,4,4,4,4,4,4
	db 4,4,4,4,4,4,4,4
	db 0

image_sequence
	dw blank,blank,blank,blank,blank,blank,blank
	dw blank,blank,blank,blank,blank,blank,blank,blank
	dw robotdd,robotdd,robotdd,robotdd
	dw robotdd,robotdd,robotdd,robotdd
	dw robotshl,robotdd,robotshr,robotdd
	dw robotshl,robotdd,robotshr,robotdd
	dw robotdr,robotdd,robotdr,robotdd
	dw robotld,robotdd,robotld,robotdd,robotdr,robotdd,robotdu,robotdd
	dw robotld,robotdd,robotud,robotdd,robotur,robotlu,robotur,robotdd
	dw robotlu,robotur,robotlu,robotdd
	dw robotfr,robotddp1,robotflp1,robotdd,robotfl,robotddm1,robotfrm1,robotdd
;	dw robotfr,robotddp1,robotflp1,robotdd,robotfl,robotddm1,robotfrm1,robotdd
	dw willyl0,willyl1,willyl2,willyl3,willyl4,willyl5,willyl6,willyl7
	dw willyr0,willyr1,willyr2,willyr3,willyr4,willyr5,willyr6,willyr7
	dw willyl0,willyl1,willyl2,willyl3,willyl4,willyl5,willyl6,willyl7
	dw willyr0,willyr1,willyr2,willyr3,willyr4,willyr5,willyr6,willyr7
	dw ivp0,ivp1,ivp0,ivp1,ivp0,ivp1,ivp0,ivp1
	dw fill0,fill1,fill2,fill3,drink0,drink1,drink2,drink3
	dw fill0,fill1,fill2,fill3,drink0,drink1,drink2,drink3
	dw fill0,fill1,fill2,fill3,drink0,drink1,drink2,drink3
	dw willyl7,willyl6,willyl5,willyl4,willyl3,willyl2,willyl1,willyl0
	dw willyr7,willyr6,willyr5,willyr4,willyr3,willyr2,willyr1,willyr0
	dw fill0,fill1,fill2,fill3,drink0,drink1,drink2,drink3
	dw fill0,fill1,fill2,fill3,drink0,drink1,drink2,drink3
	dw robotur,robotlu,robotur,robotlu,fill0,fill1,fill2,fill3
	dw willyr7,willyr6,willyr5,willyr4,willyr3,willyr2,willyr1,willyr0
	dw fill0,fill1,fill2,fill3,drink0,drink1,drink2,drink3
	dw deadwilly1,deadwilly2,deadwilly1,deadwilly2,deadwilly1,deadwilly2,deadwilly1,deadwilly2
	dw hund
	dw 0

palette_change
palette_change_ctr
	ld hl,0x40
	inc hl
	res 1,h
	ld (palette_change_ctr+1),hl
	ld a,h
	or l
	cp 0x38
	jr z,chgink
	cp 0x18
	ret nz
chgpaper
	ld hl,bgcolours
	inc l
	res 3,l
	ld (chgpaper+1),hl
	ld a,(hl)
	ld (chgink_col+1),a
	add a,a
	add a,a
	add a,a
	ld c,a
	ld a,(bgcolour+1)
	and 0xc7
	or c
	ld (bgcolour+1),a
	ret

chgink
	ld a,(bgcolour+1)
	and 0xf8
chgink_col
	or 0
	ld (bgcolour+1),a
	ret
	

	include 'stc_player.asm'	; provides stc_init and stc_play
	incbin 'neverland_looped.stc'

	org 0xbb00
ditherpattern
	; bitmaps
	db 0x11, 0x44, 0x55, 0x55, 0x22, 0x88, 0xaa, 0xaa
	db 0xdd, 0x77, 0xff, 0xff, 0xee, 0xbb, 0xff, 0xff
	; 01 = no change, 02 = draw PAPER image, 03 = draw INK image
	db 0x02, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01
	db 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01

	db 0xee, 0xbb, 0xaa, 0xaa, 0xdd, 0x77, 0x55, 0x55
	db 0x22, 0x88, 0x00, 0x00, 0x11, 0x44, 0x00, 0x00
	db 0x03, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01
	db 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01

	; rows
	db 0x41, 0x43, 0x41, 0x43, 0x42, 0x44, 0x42, 0x44
	db 0x41, 0x43, 0x41, 0x43, 0x42, 0x44, 0x42, 0x44
	db 0x41, 0x43, 0x41, 0x43, 0x42, 0x44, 0x42, 0x44
	db 0x41, 0x43, 0x41, 0x43, 0x42, 0x44, 0x42, 0x44
	db 0x41, 0x43, 0x41, 0x43, 0x42, 0x44, 0x42, 0x44
	db 0x41, 0x43, 0x41, 0x43, 0x42, 0x44, 0x42, 0x44
	db 0x41, 0x43, 0x41, 0x43, 0x42, 0x44, 0x42, 0x44
	db 0x41, 0x43, 0x41, 0x43, 0x42, 0x44, 0x42, 0x44

	; bitmaps: faster fade
;	db 0x11, 0x55, 0x55, 0x22, 0xaa, 0xee, 0xff, 0xff
;	db 0xdd, 0xff, 0xff, 0x02, 0x01, 0x01, 0x01, 0x01
;	db 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01
;	db 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01
;
;	db 0xee, 0xaa, 0xaa, 0xdd, 0x55, 0x11, 0x00, 0x00
;	db 0x22, 0x00, 0x00, 0x03, 0x01, 0x01, 0x01, 0x01
;	db 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01
;	db 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01
;
;	; rows
;	db 0x41, 0x43, 0x41, 0x42, 0x44, 0x42, 0x44, 0x42
;	db 0x41, 0x43, 0x41, 0x44, 0x44, 0x44, 0x44, 0x44
;	db 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44
;	db 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44
;	db 0x41, 0x43, 0x41, 0x42, 0x44, 0x42, 0x44, 0x42
;	db 0x41, 0x43, 0x41, 0x44, 0x44, 0x44, 0x44, 0x44
;	db 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44
;	db 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44

	org 0xbd00
sine
	include "sine32.asm"
	
	org 0xbfbf
	push af
	push bc
	push de
	push hl
	push ix
;	ld a,2
;	out (254),a
	call wavebg
;	ld a,3
;	out (254),a
	call scroller
;	ld a,4
;	out (254),a
	call dither
;	ld a,6
;	out (254),a
	call palette_change
	call stc_play
	xor a
	out (254),a
	pop ix
	pop hl
	pop de
	pop bc
	pop af
	ei
	ret

	org 0xc000
background
	include "rings.asm"

image_mask
	ds 0x0600

bgcolours
	db 4,6,5,3,5,6,7,2

gfx
	include "gfxdefs.asm"
	include "gfx.asm"

font
	include "notropol.asm"
